<template>
    <div class="d-flex flex-column justify-content-center full-height-bg">
        <div class="d-flex justify-content-center">
            <div class="card m-2" style="min-width: 450px; min-height: 450px; border-color: rgba(0,0,0,0.20)">
                <div class="card-body">
                    <form>

                        <div class="form-group row">
                            <span class="col-12 text-center logo"><i class="fas fa-bolt"></i></span>
                            <span class="col-12 text-center font-weight-light h3">LOGIN</span>
                        </div>


                        <div class="form-group row">
                            <label for="email" class="col-sm-4 col-form-label text-md-right">E-Mail Address</label>

                            <div class="col-md-8">
                                <input id="email" type="text" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.email}]" name="email" v-model="email" required autofocus>

                                <template v-if="validationError && validationError.email">
                                    <span class="invalid-feedback">
                                        <strong>{{ validationError.email[0] }}</strong>
                                    </span>
                                </template>

                            </div>
                        </div>

                        <div class="form-group row">
                            <label for="password" class="col-md-4 col-form-label text-md-right">Password</label>

                            <div class="col-md-8">
                                <input id="password" type="password" v-bind:class="['form-control',  {'is-invalid' : validationError && validationError.password}]" name="password" v-model="password" required>

                                <template v-if="validationError && validationError.password">
                                    <span class="invalid-feedback">
                                        <strong>{{ validationError.password[0] }}</strong>
                                    </span>
                                </template>
                            </div>
                        </div>

                        <div class="form-group row">
                            <div class="col-md-6 offset-md-4">

                                <div class="custom-control custom-checkbox">
                                    <input type="checkbox" class="custom-control-input" id="rememberCheckbox" name="remember">
                                    <label class="custom-control-label" for="rememberCheckbox">Remember Me</label>
                                </div>
                            </div>
                        </div>

                        <template v-if="success || fail">
                            <template v-if="success">
                                <div class="alert alert-success text-center" role="alert">
                                    {{ this.success.message }}
                                </div>
                            </template>

                            <template v-if="fail">
                                <div class="alert alert-danger text-center" role="alert">
                                    {{ this.fail.message }}
                                </div>
                            </template>
                        </template>

                        <div class="form-group row">
                            <div class="col-md-8 offset-md-4">
                                <button type="submit" class="btn btn-outline-primary" v-on:click.prevent="login" v-if="!loading">
                                    Login
                                </button>
                                <button type="submit" class="btn btn-outline-primary" v-else disabled>
                                    <i class="fas fa-spinner fa-spin"></i> Login
                                </button>
                            </div>
                        </div>

                        <div class="form-group row">
                            <span class="col-md-8 offset-md-4 my-1">
                                <router-link to="/register">Don't Have an Account? Register.</router-link>
                            </span>
                        </div>

                        <div class="row">
                            <span class="col-12 text-center"><router-link to="/"><i class="fas fa-arrow-left"></i> Back To Home</router-link></span>
                        </div>
                    </form>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
    export default {
        data: function() {
            return {
                // Inputs
                email: '',
                password: '',

                // Flags
                loading: false,

                // Process status
                success: false,
                fail: false,

                // Validation Error
                validationError: '',
            }
        },
        methods: {
            login: function() {
                // Show Loading
                this.loading = true;

                // Clear previous status messages
                this.success = false;
                this.fail = false;
                this.validationError = '';

                // Send a login request to the API
                axios.post('/api/login', {'email': this.email, 'password': this.password})
                    .then(response => {
                        console.log('Login successful. Response content: ');
                        console.log(response);

                        response = response.data;

                        // Store the access token inside localStorage
                        localStorage.setItem('access_token', response.access_token);
                        localStorage.setItem('refresh_token', response.refresh_token);

                        // Store the user_type in the Vuex store
                        this.$store.commit('setUserType', response.user_type);

                        // Redirect to the home page of the logged in user
                        this.$router.go('/login');

                        this.success = {
                            message: 'Login Successful. Redirecting...'
                        };

                    })
                    .catch(error => {
                        if (error.response) {
                            // The request was made and the server responded with a status code
                            // that falls out of the range of 2xx
                            console.log(error.response.status);

                            // Handle validation errors
                            if (error.response.status === 422) {
                                this.validationError = error.response.data.errors;
                            } else if(error.response.status === 401) { // Incorrect email-password combination
                                this.validationError = {
                                    email: [error.response.data.message]
                                };

                                // Clear password input field
                                this.password = '';
                            } else {
                                this.fail = {
                                    message: 'Something went wrong. Check the log.'
                                };
                            }

                        } else if (error.request) {
                            // The request was made, but no response was received
                            console.log(error.request);

                            this.fail = {
                                message: 'Something went wrong. Check the log.'
                            };

                        } else {
                            // Something happened in setting up the request that triggered an error
                            console.log('Error', error.message);

                            this.fail = {
                                message: 'Something went wrong. Check the log.'
                            };
                        }
                    })
                    .then(e => {
                        // Hide the loading
                        this.loading = false;
                    });

            }
        },
        mounted() {
            console.log('Login Component mounted.')
        }
    }
</script>

<style scoped>
    body {
        background-color: #FFFFFF;
    }

    .full-height-bg {
        height: 100vh;
        background-color: #FFFFFF;
    }

    .logo {
        font-size: 3rem;
    }


    @media (max-width: 576px) {
        .full-height-bg {
            height: 100vh;
        }
    }
</style>
